//+------------------------------------------------------------------+
#property link      "EAX Dashboard"
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 3
#property indicator_color1 RoyalBlue
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_width1 1
#property indicator_width2 0
#property indicator_width3 0
#property indicator_level1 20
#property indicator_level2 80
#property  indicator_levelcolor Gray


extern bool      AlertOn           = false;
extern int       EMA_Period         = 5;
extern int       Stochastic_Period  = 8;
extern double    Smooth_Coefficient = 2.0;
extern int       OverBought_Level   = 80;
extern int       OverSold_Level     = 20;


double DssBuffer[];
double MitBuffer[];
double DssBuffer_UP[];
double DssBuffer_DW[];


double S_C;
//double Smooth_Coefficient;
datetime alertonce = 0;

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,DssBuffer);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DssBuffer_UP);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexArrow(1,233);
   SetIndexBuffer(2,DssBuffer_DW);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexArrow(2,234);

   SetIndexBuffer(3,MitBuffer);
   
   SetIndexEmptyValue(0, 0.0);
   SetIndexLabel(0, "");
   SetIndexEmptyValue(1, 0.0);
   SetIndexLabel(1, "Up");
   SetIndexEmptyValue(2, 0.0);
   SetIndexLabel(2, "Down");

   IndicatorShortName ("ScalperFix  ("+EMA_Period+","+Stochastic_Period+")");

  ( S_C = Smooth_Coefficient / (0.0 + EMA_Period));
   return(0);
}


int start()
{
   int i, limit, counted_bars=IndicatorCounted(), Bar_OK;
   if (counted_bars == 0)   limit = Bars - Stochastic_Period;
   if (counted_bars > 0)   limit = Bars - counted_bars;
   
   double HighRange, LowRange;
   double delta, MIT;
   for (i = limit; i >= 0; i--)
   {
      HighRange = High[iHighest(NULL,0,MODE_HIGH,Stochastic_Period,i)];
      LowRange = Low[iLowest(NULL,0,MODE_LOW,Stochastic_Period,i)];
      delta = Close[i] - LowRange;
      MIT = delta/(HighRange - LowRange)*100.0;
      MitBuffer[i] = S_C * (MIT - MitBuffer[i+1]) + MitBuffer[i+1];
   }

   double DSS;
   for (i = limit; i >= 0; i--)
   {
      HighRange = MitBuffer[ArrayMaximum(MitBuffer, Stochastic_Period, i)];
      LowRange = MitBuffer[ArrayMinimum(MitBuffer, Stochastic_Period, i)];
      delta = MitBuffer[i] - LowRange;
      DSS = delta/(HighRange - LowRange)*100.0;
      DssBuffer[i] = S_C * (DSS - DssBuffer[i+1]) + DssBuffer[i+1];
   }

   for (i = limit; i >= 0; i--)
   {
      //DssBuffer_UP[i]=EMPTY_VALUE;
      //DssBuffer_DW[i]=EMPTY_VALUE;
      Bar_OK=0;
      
      if(DssBuffer[i]>DssBuffer[i+1])
      {
         DssBuffer_UP[i]=DssBuffer[i];
         Bar_OK=1;
         DssBuffer_DW[i] = 0.0;
      }

      if(DssBuffer[i]<DssBuffer[i+1])
      {
         DssBuffer_DW[i]=DssBuffer[i];
         Bar_OK=1;
         DssBuffer_UP[i] = 0.0;
      }

      if(Bar_OK==0)
      {
         DssBuffer_UP[i]=DssBuffer_UP[i+1];
         DssBuffer_DW[i]=DssBuffer_DW[i+1];
      }   
   }

   if ( AlertOn && alertonce != Time[0] )
      {
         if ( DssBuffer_DW[1] < OverSold_Level && DssBuffer_DW[2] <  OverSold_Level)
            {
               Alert(Symbol(), " ScalperFix BUY ", Period(), " Min. ", Close[0]  );
               SendMail (" ",Symbol()+" "+Period()+": Buy Alert @ "+DoubleToStr(Bid,Digits));
               alertonce = Time[0];
            }
         if ( DssBuffer_UP[1] > OverBought_Level && DssBuffer_UP[2] > OverBought_Level)
            {
               Alert(Symbol(), " ScalperFix SELL ", Period(), " Min. ", Close[0] );
               SendMail (" ",Symbol()+" "+Period()+": Sell Alert @ "+DoubleToStr(Bid,Digits));
               alertonce = Time[0];
            }     
      }
   
   return(0);
}